This patch changes sequence of commands sent to IRC server doing JOIN #channel.
Now the join commands are sent when bot connects to the server. it can be initial connect or reconnect due KILL or timeout.

Bugs: JOIN commands are sent more than once due MOTD messages being sent several times.
Sideeffects: could cause FLOOD on irc server.

--- bot.php	2005-06-13 13:30:08.000000000 +0300
+++ ./misc/bot.php	2005-06-14 19:24:17.000000000 +0300
@@ -258,6 +258,14 @@
         return $channels[$prj_id];
     }
     
+
+    function _joinChannels(&$irc)
+    {
+        foreach ($GLOBALS['channels'] as $prj_id => $channel_list) {
+            $irc->join($channel_list);
+        }
+    }
+
     
     /**
      * Helper method to the projects a channel displays messages for.
@@ -367,12 +375,14 @@
 $irc->setLogdestination(SMARTIRC_FILE);
 $irc->setLogfile(APP_IRC_LOG);
 $irc->setUseSockets(TRUE);
-$irc->setAutoReconnect(FALSE);
+$irc->setAutoReconnect(TRUE);
 $irc->setAutoRetry(TRUE);
 
 // register saytime() to be called every 30 sec. (30,000 milliseconds)
 $irc->registerTimehandler(3000, $bot, 'notifyEvents');
 
+$irc->registerActionhandler(SMARTIRC_TYPE_LOGIN, '.*', $bot, '_joinChannels');
+
 // methods that keep track of who is authenticated
 $irc->registerActionhandler(SMARTIRC_TYPE_QUERY, '^!?list-auth', $bot, 'listAuthenticatedUsers');
 $irc->registerActionhandler(SMARTIRC_TYPE_NICKCHANGE, '.*', $bot, '_updateAuthenticatedUser');
@@ -387,12 +397,9 @@
 
 $irc->connect($irc_host, $irc_port);
 $irc->login($irc_nick, $irc_realname, 0, $irc_username, $irc_password);
-foreach ($channels as $prj_id => $channel_list) {
-    $irc->join($channel_list);
-}
 $irc->listen();
 $irc->disconnect();
 
 // release the lock
 Lock::release('irc_bot');
-?>
\ No newline at end of file
+?>
